package net.zhypower.ntsample.test;


import junit.framework.Test;
import junit.framework.TestSuite;
import net.zhypower.sample.R;
import net.zhypower.sample.RegisterActivity;
import net.zhypower.sample.UserParcelable;
import android.app.Activity;
import android.content.Intent;
import android.test.ActivityInstrumentationTestCase2;
import android.view.KeyEvent;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Spinner;

public class RegisterUnitTest extends ActivityInstrumentationTestCase2<RegisterActivity> {


    public RegisterUnitTest(Class<RegisterActivity> activityClass) {
        super(activityClass);
    }

    public RegisterUnitTest() {
        this(RegisterActivity.class);
    }
    
    public RegisterUnitTest(String name) {
        this(RegisterActivity.class);
        setName(name);
    }

    public static Test suite() {
        TestSuite suite = new TestSuite("test");
        suite.addTest(new RegisterUnitTest("test_menu"));
        suite.addTest(new RegisterUnitTest("test_mofify"));
        return suite;
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void test_menu() {
        Activity act = getActivity();
        sendKeys(KeyEvent.KEYCODE_MENU);
        boolean success = getInstrumentation().invokeMenuActionSync(act, R.id.version, 0);
        assertTrue(success);
    }
    
    public void test_mofify() {
        UserParcelable user = new UserParcelable();
        user.setSex("女");
        user.setAge("30世代");
        user.setPassword("password");
        user.setUserid("testid");
        Intent intent = new Intent();
        intent.putExtra("userinfo", user);
        
        setActivityIntent(intent);
        Activity registerActivity = getActivity();
        
        final EditText useridElem = (EditText) registerActivity
                .findViewById(R.id.userid);
        final EditText pwdElem = (EditText) registerActivity
                .findViewById(R.id.pwd);
        final EditText pwdCfmElem = (EditText) registerActivity
                .findViewById(R.id.pwd_confirm);
        final CheckBox dspPwdElem = (CheckBox) registerActivity
                .findViewById(R.id.display_password);
        final RadioButton womanElem = (RadioButton) registerActivity
                .findViewById(R.id.sex_woman);
        final Spinner ageElem = (Spinner) registerActivity
                .findViewById(R.id.age);

        assertEquals("testid", useridElem.getText().toString());
        assertEquals("password",pwdElem.getText().toString());
        assertEquals("password",pwdCfmElem.getText().toString());
        
        assertFalse(dspPwdElem.isChecked());
        assertTrue(womanElem.isChecked());
        assertEquals(2, ageElem.getSelectedItemPosition());
        
    }
}
